#include "GL_UpdaterCoreVisitor.h"
#include "GL_X3DNode.h"
#include "GL_Scene.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace GL {

UpdaterCoreVisitor::UpdaterCoreVisitor()
: CoreVisitor()
{
  // Enter functions.
  defineEnterFunction(&UpdaterCoreVisitor::enterScene);
  defineEnterFunction(&UpdaterCoreVisitor::enterX3DNode);
}

void UpdaterCoreVisitor::enterScene(Scene *S) 
{
  UpdaterStateVariables *stateVariables = GraphTraversal::getInstanceOf<UpdaterStateVariables>();
  S->update();
  
  if (chdir(S->getFileName().getPath()) != 0)
    cx3d << "GLBuilderCoreVisitor::enterScene: unable to set the current working directory to " << S->getFileName().getPath() << "!" << endl; 
}

void UpdaterCoreVisitor::enterX3DNode(X3DNode *N) 
{
  UpdaterStateVariables *stateVariables = GraphTraversal::getInstanceOf<UpdaterStateVariables>();
  N->update();
}

}
}
