#include "MESH_ConnectedComComputer.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace MESH {

ConnectedComComputer::ConnectedComComputer()
: X3DMultiPassProcessor()
{
  progress = new Progress(256);
  stateVariables = GraphTraversal::getInstanceOf<ConnectedComComputerStateVariables>();
  stateVariables->setProgress(progress);
  
  graphTraversalMap["Vertex"] = new DFSGraphTraversal();
  graphTraversalMap["Vertex"]->setComponentVisitor(new ConnectedComComputerCoreVisitor(progress));
  
//  graphTraversalMap["Mesh"] = new DFSGraphTraversal();
//  graphTraversalMap["Mesh"]->setComponentVisitor(new ConnectedComComputerMeshCoreVisitor());
}

ConnectedComComputer::~ConnectedComComputer()
{
  GraphTraversal::removeInstanceOf<ConnectedComComputerStateVariables>();
  delete progress;
  delete graphTraversalMap["Vertex"];
//  delete graphTraversalMap["Mesh"];
}

void ConnectedComComputer::compute(X3DNode *N)
{
  stateVariables->init();
  graphTraversalMap["Vertex"]->traverse(N);
  stateVariables->finish(); 
/*  std::cout << "vs ok" << std::endl;
  graphTraversalMap["Mesh"]->traverse(N);
  stateVariables->finish(); 
  std::cout << "mesh ok" << std::endl;  */
}

void ConnectedComComputer::setSelectedNodes(const MFNode &selectedNodes)
{
  stateVariables->setSelectedNodes(selectedNodes);
}

}
}  
