#include "ClonerAbstractVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {

ClonerAbstractVisitor::ClonerAbstractVisitor()
{
  defineEnterFunction(&ClonerAbstractVisitor::enterX3DAbstractNode);
  defineLeaveFunction(&ClonerAbstractVisitor::leaveX3DAbstractNode);
}

void ClonerAbstractVisitor::enterX3DAbstractNode(X3DAbstractNode *N) 
{
  ClonerStateVariables *stateVariables = GraphTraversal::getInstanceOf<ClonerStateVariables>();
  
  SFAbstractNode NN = stateVariables->getNode(N);
  if (NN == 0)
  {
    NN = N->clone();
    
    stateVariables->addCoupleNode(N, NN);
    // removing children.
    MFAbstractNode childList = NN->getChildList();
    for (MFAbstractNode::const_iterator it = childList.begin(); it != childList.end(); ++it)
      NN->removeChild(*it);
  }
    
  stateVariables->pushNode(NN);
}

void ClonerAbstractVisitor::leaveX3DAbstractNode(X3DAbstractNode *) 
{
  ClonerStateVariables *stateVariables = GraphTraversal::getInstanceOf<ClonerStateVariables>();
  stateVariables->popNode();
}

}
