#include "MemReleaser.h"
#include "DFSGraphTraversal.h"
#include "MemReleaserAbstractVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {

MemReleaser::MemReleaser()
: X3DMemReleaser()
{
  stateVariables = GraphTraversal::getInstanceOf<MemReleaserStateVariables>();
  
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new MemReleaserAbstractVisitor());
}

MemReleaser::~MemReleaser()
{
  GraphTraversal::removeInstanceOf<MemReleaserStateVariables>();
  delete graphTraversal;
}

void MemReleaser::release(SFAbstractNode N)
{
  stateVariables->init();
  graphTraversal->traverse(N);
  stateVariables->finish();
}

void MemReleaser::init()
{
  stateVariables->init();
}

void MemReleaser::finish()
{
  stateVariables->finish();
}

}
